<template>
  <div>
    <div class="table-loader-man-hour">
      <div
        class="text-center"
        v-bind:class="{
          'd-none': loadingActive
        }"
      >
        <div class="text-center">
          <div class="spinner-border text-secondary" role="status">
            <span class="visually-hidden"></span>
          </div>
        </div>
      </div>
    </div>

    <div
      v-bind:class="{
        'd-none': tableManHour
      }"
    >
      <div class="card card-custom p-5 gutter-b">
        <div class="card-body p-0">
          <div class="row">
            <div class="col-md-6 py-2 col-sm-12">
              <label for="input-large">Nickname</label>

              <b-form-select
                v-model="filter.nickname"
                :options="projectNicknameOptions"
                size="lg"
              ></b-form-select>
            </div>

            <div class="col-md-6 py-2 col-sm-12">
              <label for="input-large">Owner</label>

              <b-form-input
                id="input-large"
                size="lg"
                disabled
                placeholder="Masukkan Owner"
                v-model="selectedNickname.ownerName"
              ></b-form-input>
            </div>

            <div class="col-md-6 py-2 col-sm-12">
              <label for="input-large">Nama Proyek</label>

              <b-form-input
                id="input-large"
                size="lg"
                disabled
                placeholder="Masukkan Nama Proyek"
                v-model="selectedNickname.projectName"
              ></b-form-input>
            </div>

            <div class="col-md-6 py-2 col-sm-12">
              <label for="input-large">Nomor Kontrak</label>

              <b-form-input
                id="input-large"
                size="lg"
                disabled
                placeholder="Masukkan Nomor Kontrak"
                v-model="selectedNickname.contractNumber"
              ></b-form-input>
            </div>

            <div class="col-md-6 py-2 col-sm-12">
              <label for="input-large">Status</label>

              <b-form-input
                disabled
                v-model="selectedNickname.status"
                id="input-large"
                size="lg"
                placeholder="Masukkan Status"
              ></b-form-input>
            </div>
          </div>
        </div>
      </div>

      <div class="card card-custom p-5 gutter-b">
        <div class="card-body p-0">
          <div class="row">
            <div class="col-md-6 py-2 col-sm-12">
              <label for="input-large">Stasiun</label>

              <b-form-select
                v-model="filter.station"
                :options="options.stations"
                size="lg"
              ></b-form-select>
            </div>

            <div class="col-md-6 py-2 col-sm-12">
              <label for="input-large">Scope</label>
              <b-form-select
                v-model="filter.scope"
                :options="scopeOptions"
                size="lg"
              ></b-form-select>
            </div>

            <div class="col-md-6 py-2 col-sm-12">
              <label for="input-large">Title</label>

              <b-form-input
                id="input-large"
                size="lg"
                placeholder="Masukkan Title"
              ></b-form-input>
            </div>
          </div>

          <div class="d-flex justify-content-end">
            <button class="btn btn-primary btn-md">
              <i class="flaticon2-search-1"></i> Filter
            </button>
          </div>
        </div>
      </div>

      <div class="card card-custom p-5 gutter-b">
        <div class="card-body p-0">
          <b-tabs content-class="mt-3">
            <b-tab title="Document">
              <document :project="selectedNickname"></document>
            </b-tab>

            <b-tab title="Drawing">
              <drawing :project="selectedNickname"></drawing>
            </b-tab>

            <b-tab title="Software">
              <software :project="selectedNickname"></software>
            </b-tab>
          </b-tabs>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { SET_BREADCRUMB } from "@/core/services/store/breadcrumbs.module";
import Document from "./man-hour/Document.vue";
import Drawing from "./man-hour/Drawing.vue";
import Software from "./man-hour/Software.vue";
import { GET_SCOPES } from "@/core/services/store/scope.module";
import { GET_STATION_BY_PROJECT } from "@/core/services/store/station.module";
import {
  FILTER_PROJECT_DETAIL,
  GET_PROJECT_DETAIL
} from "@/core/services/store/project.module";
import { mapGetters } from "vuex";

export default {
  name: "ManHour",
  components: {
    Document,
    Drawing,
    Software
  },
  data() {
    return {
      filter: {
        status: null,
        name: null,
        code: null,
        owner: null,
        contractNumber: null,
        nickname: null,
        station: null,
        scope: null
      },
      selectedNickname: {
        code: null,
        ownerName: null,
        projectName: null,
        status: null,
        contractNumber: null
      },
      options: {
        statuses: [
          { value: null, text: "Pilih Status" },
          { value: "open", text: "Open" },
          { value: "close", text: "Close" }
        ],
        nicknames: [{ value: null, text: "Pilih Nickname" }],
        stations: [{ value: null, text: "Pilih Stasiun" }],
        scopes: [{ value: null, text: "Pilih Scope" }]
      },
      data: {
        projects: [
          {
            code: "LR98123",
            name: "PEMBANGUNAN SISTEM PERSINYALAN",
            status: "Open",
            owner: "BALAI TEKNIK PERKERETAAPIAN"
          }
        ]
      },
      loadingActive: false,
      tableManHour: true
    };
  },
  methods: {
    getProjectByNickName(nickname) {
      const filter = {
        jobdesk: "design",
        params: {
          nickname: nickname === null ? "" : nickname
        }
      };
      this.$store.dispatch(FILTER_PROJECT_DETAIL, filter);
    },

    getStationByProject(projectID) {
      this.$store.dispatch(GET_STATION_BY_PROJECT, projectID).then(() =>
        this.currentStationProject.stations.map(stationProject => {
          this.options.stations.push({
            value: stationProject.code,
            text: stationProject.name
          });
        })
      );
    }
  },
  async created() {
    await this.$store.dispatch(SET_BREADCRUMB, [{ title: "Man Hour" }]);
    await this.$store.dispatch(GET_SCOPES);
    await this.$store.dispatch(GET_PROJECT_DETAIL, "design");

    this.loadingActive = true;
    this.tableManHour = false;
  },
  computed: {
    ...mapGetters([
      "currentScopes",
      "currentStationProject",
      "projectNicknameOptions",
      "currentProjectDetails"
    ]),
    scopeOptions() {
      var result = [{ value: null, text: "Pilih Scope" }];
      this.currentScopes.map(scope => {
        result.push({
          value: scope.code,
          text: scope.name
        });
      });
      return result;
    },
    currentNickname() {
      return this.filter.nickname;
    }
  },
  watch: {
    currentNickname(value) {
      if (!value) {
        Object.assign(this.selectedNickname, {
          code: null,
          ownerName: null,
          projectName: null,
          status: null,
          contractNumber: null
        });

        this.options.stations = [{ value: null, text: "Pilih Stasiun" }];

        return;
      }

      const project = this.currentProjectDetails.find(x => x.nickname === this.filter.nickname ); 
      
      Object.assign(this.selectedNickname, 
      { 
        ownerName: project?.owner, 
        projectName: project?.name, 
        status: project?.status, 
        contractNumber: project?.contract_no,
        ...project 
      });


      this.getStationByProject(this.selectedNickname.code);
    }
  }
};
</script>

<style></style>
